Subject: bug#5808: 23.1; substitute-in-file-name $NOSUCH vs ${NOSUCH}

From: Kevin Ryde <[email-masked]>
Date: Wed, 31 Mar 2010 11:18:39 +1100

Evaluating

    (substitute-in-file-name "$NOSUCHVAR")
    => "$NOSUCHVAR

but

    (substitute-in-file-name "${NOSUCHVAR}")
    => error
    Substituting nonexistent environment variable "NOSUCHVAR"

whereas I thought the two ways of writing a variable would be treated
the same.

I'm not sure if this is a bug or a feature.  I see they were both errors
in Emacs 21, but that 22 up forgives the first.

If a feature then it'd be good if the docstring had a note explaining
the difference.  I'd used then first and then got bitten from the second
throwing an error.

The docstring might also note unpaired braces are an error

    (substitute-in-file-name "${HOME")
    => error

primarily in the interests of knowing what circumstances you might have
to condition-case or ignore-errors.

In GNU Emacs 23.1.1 (i486-pc-linux-gnu, GTK+ Version 2.16.5)
 of 2009-09-14 on raven, modified by Debian
configured using `configure  '--build=i486-linux-gnu' '--host=i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.1/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.1/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.1/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'host_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_AU
  value of $XMODIFIERS: nil
  locale-coding-system: iso-latin-1-unix
  default-enable-multibyte-characters: t